package com.jcg.test;

import com.jcg.calculator.Calculator;
import java.util.List;
import static org.junit.jupiter.api.Assertions.assertEquals;
import org.junit.jupiter.api.Test;

import org.mockito.MockedConstruction;

import static org.mockito.Mockito.when;
import static org.mockito.Mockito.mockConstruction;

/**
 *
 * @author omozegieaziegbe
 */
public class CalculatorTest {

    @Test
    public void testAddition() {
        
        try (MockedConstruction<Calculator> mocked = mockConstruction(Calculator.class)) {

            // creating a mock instance
            Calculator calculator = new Calculator();

            // Mock behaviour
            when(calculator.add(10, 20)).thenReturn(30);
            when(calculator.subtract(30, 20)).thenReturn(10);

            // Test the methods
            assertEquals(30, calculator.add(10, 20));
            assertEquals(10, calculator.subtract(30, 20));

            // Get a list of all created mocks
            List<Calculator> constructed = mocked.constructed();
            assertEquals(1, constructed.size());

        }
    }
}
