package com.jcg.test;

import com.jcg.person.Person;
import java.util.List;
import static org.junit.jupiter.api.Assertions.assertEquals;
import org.junit.jupiter.api.Test;
import org.mockito.MockedConstruction;
import static org.mockito.Mockito.mockConstruction;
import static org.mockito.Mockito.when;

/**
 *
 * @author omozegieaziegbe
 */
public class PersonTest {

    @Test
    public void testPersonManager() {
        try (MockedConstruction<Person> mocked = mockConstruction(Person.class)) {

            // create a mock instance
            Person person = new Person("John");

            when(person.getHeight()).thenReturn("190");
            when(person.getName()).thenReturn("John");

            String name = person.getName();

            assertEquals("190", person.getHeight());
            //assertEquals(null, person.getName());
            assertEquals("John", name);

            // Get list of all created mocks
            List<Person> constructed = mocked.constructed();
            assertEquals(1, constructed.size());
        }
    }
}
